# Upload a required immigration document

POST https://api.letsdeel.com/rest/v2/immigration/workers/{worker_id}/cases/{case_id}/required-document/{document_request_id}
Content-Type: multipart/form-data

Upload a required immigration document for a specific case. The document will be submitted for review.
 **Token scopes**: `worker:write`

Reference: https://developer.deel.com/api/endpoints/immigration/create-worker-case-required-document

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Deel HRIS SCIM API
  version: 1.0.0
paths:
  /immigration/workers/{worker_id}/cases/{case_id}/required-document/{document_request_id}:
    post:
      operationId: create-worker-case-required-document
      summary: Upload a required immigration document
      description: >-
        Upload a required immigration document for a specific case. The document
        will be submitted for review.
         **Token scopes**: `worker:write`
      tags:
        - subpackage_immigration
      parameters:
        - name: worker_id
          in: path
          description: The hris profile oid (public id) of the worker.
          required: true
          schema:
            type: string
        - name: case_id
          in: path
          description: >-
            The unique identifier of the case for which the required document is
            being requested.
          required: true
          schema:
            type: string
        - name: document_request_id
          in: path
          description: >-
            The unique identifier of the document request fo which this document
            is being uplodaded
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: >
            ## Authentication

            The Deel API uses bearer tokens to authenticate requests. All API
            calls must be made over HTTPS — calls over plain HTTP or without
            authentication will fail.


            ```curl

            curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
              -H 'Authorization: Bearer YOUR-TOKEN-HERE'
            ```


            [Learn more about authentication](/api/authentication)
          required: true
          schema:
            type: string
      responses:
        '201':
          description: Document uploaded.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/immigration_createWorkerCaseRequiredDocument_Response_201
        '400':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '401':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '403':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '404':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '500':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
      requestBody:
        description: Upload of immigration document
        content:
          multipart/form-data:
            schema:
              type: object
              properties:
                data:
                  $ref: >-
                    #/components/schemas/ImmigrationWorkersWorkerIdCasesCaseIdRequiredDocumentDocumentRequestIdPostRequestBodyContentMultipartFormDataSchemaData
                  description: Details of immigration document upload
              required:
                - data
servers:
  - url: https://api.letsdeel.com/rest/v2
  - url: https://api-staging.letsdeel.com/rest/v2
components:
  schemas:
    ImmigrationWorkersWorkerIdCasesCaseIdRequiredDocumentDocumentRequestIdPostRequestBodyContentMultipartFormDataSchemaData:
      type: object
      properties:
        file:
          type: string
          format: binary
          description: >-
            Immigration right to work document. More than 1 document can be
            uploaded at the same time (e.g.: front and back)
      required:
        - file
      description: Details of immigration document upload
      title: >-
        ImmigrationWorkersWorkerIdCasesCaseIdRequiredDocumentDocumentRequestIdPostRequestBodyContentMultipartFormDataSchemaData
    ImmigrationWorkersWorkerIdCasesCaseIdRequiredDocumentDocumentRequestIdPostResponsesContentApplicationJsonSchemaDataStatus:
      type: string
      enum:
        - IN_REVIEW
      description: Status of the document.
      title: >-
        ImmigrationWorkersWorkerIdCasesCaseIdRequiredDocumentDocumentRequestIdPostResponsesContentApplicationJsonSchemaDataStatus
    ImmigrationWorkersWorkerIdCasesCaseIdRequiredDocumentDocumentRequestIdPostResponsesContentApplicationJsonSchemaData:
      type: object
      properties:
        id:
          type: string
          description: Unique identifier of the document.
        status:
          $ref: >-
            #/components/schemas/ImmigrationWorkersWorkerIdCasesCaseIdRequiredDocumentDocumentRequestIdPostResponsesContentApplicationJsonSchemaDataStatus
          description: Status of the document.
        created_at:
          type: string
          format: date-time
          description: Creation date of the document.
        updated_at:
          type: string
          format: date-time
          description: Last update date of the document.
      title: >-
        ImmigrationWorkersWorkerIdCasesCaseIdRequiredDocumentDocumentRequestIdPostResponsesContentApplicationJsonSchemaData
    immigration_createWorkerCaseRequiredDocument_Response_201:
      type: object
      properties:
        data:
          $ref: >-
            #/components/schemas/ImmigrationWorkersWorkerIdCasesCaseIdRequiredDocumentDocumentRequestIdPostResponsesContentApplicationJsonSchemaData
      title: immigration_createWorkerCaseRequiredDocument_Response_201
    ApiErrorRequest:
      type: object
      properties:
        method:
          type: string
          description: The HTTP method of the failed request
        url:
          type: string
          description: The relative URL of the failed request
        status:
          type: number
          format: double
          description: The status code of the response
        api_req_id:
          type: string
          description: The request ID of the failed request
        docs:
          type: string
          description: >-
            A link to the official documentation for the requested endpoint
            resource
        source:
          type: string
          description: The source handler which produced the returned error
        code:
          type: number
          format: double
          description: The code of the source handler which produced the returned error
      title: ApiErrorRequest
    ApiError:
      type: object
      properties:
        message:
          type: string
          description: A description of the returned error
        path:
          type: string
          description: The JSON path where input validation failed
      title: ApiError
    ApiErrorContainer:
      type: object
      properties:
        request:
          $ref: '#/components/schemas/ApiErrorRequest'
        errors:
          type: array
          items:
            $ref: '#/components/schemas/ApiError'
      title: ApiErrorContainer
  securitySchemes:
    deelToken:
      type: http
      scheme: bearer
      description: >
        ## Authentication

        The Deel API uses bearer tokens to authenticate requests. All API calls
        must be made over HTTPS — calls over plain HTTP or without
        authentication will fail.


        ```curl

        curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
          -H 'Authorization: Bearer YOUR-TOKEN-HERE'
        ```


        [Learn more about authentication](/api/authentication)
    oauth2:
      type: http
      scheme: bearer
      description: >-
        Standard OAuth2 security scheme based on
        https://swagger.io/docs/specification/authentication/

```

## SDK Code Examples

```python
import requests

url = "https://api.letsdeel.com/rest/v2/immigration/workers/a6fb5c89-5abd-45d1-afc1-7e98d550eb71/cases/a6fb5c89-5abd-45d1-afc1-7e98d550eb71/required-document/a6fb5c89-5abd-45d1-afc1-7e98d550eb71"

payload = "-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"data\"\r\n\r\n{\n  \"file\": \"passport.jpg\"\n}\r\n-----011000010111000001101001--\r\n"
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "multipart/form-data; boundary=---011000010111000001101001"
}

response = requests.post(url, data=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/v2/immigration/workers/a6fb5c89-5abd-45d1-afc1-7e98d550eb71/cases/a6fb5c89-5abd-45d1-afc1-7e98d550eb71/required-document/a6fb5c89-5abd-45d1-afc1-7e98d550eb71';
const form = new FormData();
form.append('data', '{
  "file": "passport.jpg"
}');

const options = {method: 'POST', headers: {Authorization: 'Bearer <token>'}};

options.body = form;

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/v2/immigration/workers/a6fb5c89-5abd-45d1-afc1-7e98d550eb71/cases/a6fb5c89-5abd-45d1-afc1-7e98d550eb71/required-document/a6fb5c89-5abd-45d1-afc1-7e98d550eb71"

	payload := strings.NewReader("-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"data\"\r\n\r\n{\n  \"file\": \"passport.jpg\"\n}\r\n-----011000010111000001101001--\r\n")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/v2/immigration/workers/a6fb5c89-5abd-45d1-afc1-7e98d550eb71/cases/a6fb5c89-5abd-45d1-afc1-7e98d550eb71/required-document/a6fb5c89-5abd-45d1-afc1-7e98d550eb71")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request.body = "-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"data\"\r\n\r\n{\n  \"file\": \"passport.jpg\"\n}\r\n-----011000010111000001101001--\r\n"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.letsdeel.com/rest/v2/immigration/workers/a6fb5c89-5abd-45d1-afc1-7e98d550eb71/cases/a6fb5c89-5abd-45d1-afc1-7e98d550eb71/required-document/a6fb5c89-5abd-45d1-afc1-7e98d550eb71")
  .header("Authorization", "Bearer <token>")
  .body("-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"data\"\r\n\r\n{\n  \"file\": \"passport.jpg\"\n}\r\n-----011000010111000001101001--\r\n")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.letsdeel.com/rest/v2/immigration/workers/a6fb5c89-5abd-45d1-afc1-7e98d550eb71/cases/a6fb5c89-5abd-45d1-afc1-7e98d550eb71/required-document/a6fb5c89-5abd-45d1-afc1-7e98d550eb71', [
  'multipart' => [
    [
        'name' => 'data',
        'contents' => '{
  "file": "passport.jpg"
}'
    ]
  ]
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/v2/immigration/workers/a6fb5c89-5abd-45d1-afc1-7e98d550eb71/cases/a6fb5c89-5abd-45d1-afc1-7e98d550eb71/required-document/a6fb5c89-5abd-45d1-afc1-7e98d550eb71");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddParameter("undefined", "-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"data\"\r\n\r\n{\n  \"file\": \"passport.jpg\"\n}\r\n-----011000010111000001101001--\r\n", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "Bearer <token>"]
let parameters = [
  [
    "name": "data",
    "value": "{
  \"file\": \"passport.jpg\"
}"
  ]
]

let boundary = "---011000010111000001101001"

var body = ""
var error: NSError? = nil
for param in parameters {
  let paramName = param["name"]!
  body += "--\(boundary)\r\n"
  body += "Content-Disposition:form-data; name=\"\(paramName)\""
  if let filename = param["fileName"] {
    let contentType = param["content-type"]!
    let fileContent = String(contentsOfFile: filename, encoding: String.Encoding.utf8)
    if (error != nil) {
      print(error as Any)
    }
    body += "; filename=\"\(filename)\"\r\n"
    body += "Content-Type: \(contentType)\r\n\r\n"
    body += fileContent
  } else if let paramValue = param["value"] {
    body += "\r\n\r\n\(paramValue)"
  }
}

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/v2/immigration/workers/a6fb5c89-5abd-45d1-afc1-7e98d550eb71/cases/a6fb5c89-5abd-45d1-afc1-7e98d550eb71/required-document/a6fb5c89-5abd-45d1-afc1-7e98d550eb71")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```